#pragma once

#include "core/utils/utils.h"
#include "core/jobs/jobs.h"

class parallel_job : public job_base
{
public:
	using func_t = std::function<void(const size_t x, const size_t y)>;

	parallel_job(size_t xmin, size_t xmax, size_t ymin, size_t ymax, func_t func)
	{
		this->m_xmin = xmin;
		this->m_xmax = xmax;
		this->m_ymin = ymin;
		this->m_ymax = ymax;

		this->m_func = func;
	}

private:
	virtual void _run(void)
	{
		if (!this->m_func)
			return;

		for (size_t y = this->m_ymin; y < this->m_ymax; y++)
			for (size_t x = this->m_xmin; x < this->m_xmax; x++)
				this->m_func(x, y);
	}

	size_t m_xmin, m_xmax, m_ymin, m_ymax;

	func_t m_func;
};
