#pragma once

#include "core/utils/utils.h"
#include "core/debug/evemon.h"

#include "rev_polish_job.h"

/* rev_polish_job_divide job class */
class rev_polish_job_divide : public rev_polish_job_base
{
public:

	// copy reference on ctor
	rev_polish_job_divide(std::shared_ptr<rev_polish_job_base> obj1, std::shared_ptr<rev_polish_job_base> obj2)
	{
		this->m_obj1 = obj1;
		this->m_obj2 = obj2;

		add_dependency(this->m_obj1);
		add_dependency(this->m_obj2);
	}

	// return reference
	virtual const map2d<float>& get(void) const override
	{
		return this->m_result;
	}

private:

	// clear result
	virtual void _init(void) override
	{
		this->m_result.clear();
	}

	// perform operation
	virtual void _run(void) override
	{
		if (__ISNULLPTR(this->m_obj1) || __ISNULLPTR(this->m_obj2))
			throw_exception(null_job_exception);

		this->m_result = this->m_obj1->get() / this->m_obj2->get();
	}

	std::shared_ptr<rev_polish_job_base> m_obj1, m_obj2;

	map2d<float> m_result;
};
