#pragma once

#include "core/utils/utils.h"
#include "core/debug/evemon.h"

#include "rev_polish_job.h"

/* rev_polish_job_square job class */
class rev_polish_job_square : public rev_polish_job_base
{
public:

	// copy reference on ctor
	rev_polish_job_square(std::shared_ptr<rev_polish_job_base> obj)
	{
		this->m_obj = obj;

		add_dependency(this->m_obj);
	}

	// return reference
	virtual const map2d<float>& get(void) const override
	{
		return this->m_result;
	}

private:

	// clear result
	virtual void _init(void) override
	{
		this->m_result.clear();
	}

	// perform operation
	virtual void _run(void) override
	{
		if (__ISNULLPTR(this->m_obj))
			throw_exception(null_job_exception);

		this->m_result = this->m_obj->get() * this->m_obj->get();
	}

	std::shared_ptr<rev_polish_job_base> m_obj;

	map2d<float> m_result;
};
